<!--
 * @Description: 新增/编辑弹框
 * @Author: Sugar.
 * @Date: 2023-11-24 13:55:00
 * @LastEditors: Sugar.
 * @LastEditTime: 22023-11-24 13:55:00
 * @FilePath: \cattle_webui\src\views\venue\performanceHallMr\dialog\AddOrEditDialog.vue
 * @Copyright: Copyright (c) 2016~2023 by Sugar., All Rights Reserved.
-->
<template>
  <el-dialog
    :title="title"
    :visible.sync="open"
    width="700px"
    append-to-body
    :close-on-click-modal="false"
    @close="cancel"
  >
    <div class="dialog">
      <el-form :model="form" v-if="open" ref="form" :rules="rules" label-width="100px">
        <el-form-item label="演出厅名称" prop="name">
          <el-input
            v-model="form.name"
            placeholder="演出厅名称"
            clearable
            style="width: 100%;"
          />
        </el-form-item>
        <el-form-item label="所属场馆" prop="theatreId">
          <el-select
            v-model="form.theatreId"
            placeholder="所属场馆"
            clearable
            style="width: 100%"
          >
            <el-option
              v-for="dict in theatreList"
              :key="dict.id"
              :label="dict.name"
              :value="dict.id"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="票区图上传">
          <el-upload
            ref="upload"
            class="avatar-uploader"
            :action="uploadObj.url"
            :headers="uploadObj.headers"
            :show-file-list="false"
            accept=".jpg,.png"
            :on-success="handleAvatarSuccess"
            :before-upload="beforeAvatarUpload"
          >
            <div class="avatar" style="position: relative" v-if="form.seatImg">
              <el-image
                style="width: 100px; height: 100px"
                :src="form.seatImg"
                fit="cover"
              />
              <div class="img_remove">
                <el-button type="text" icon="el-icon-delete" @click.stop="removeImg">删除</el-button>
              </div>
            </div>
            <div class="upload-btn" v-else>
              <i class="el-icon-plus"></i>
              <div class="upload-btn-text">上传图片</div>
            </div>
            <div class="el-upload__tip" slot="tip">只能上传.jpg或.png格式</div>
          </el-upload>
        </el-form-item>
      </el-form>
    </div>
    <span slot="footer" class="dialog-footer">
      <el-button @click="cancel">取消</el-button>
      <el-button
        type="primary"
        @click="submitForm"
        v-loading.fullscreen.lock="loading"
        element-loading-text="提交中..."
        element-loading-spinner="el-icon-loading"
        element-loading-background="rgba(0, 0, 0, 0.8)"
      >
        <span v-if="loading">提交中...</span>
        <span v-else>保存</span>
      </el-button>
    </span>
  </el-dialog>
</template>

<script>
import { pageList } from "@/api/venueMr/venueMr";
import { saveAndEdit } from "@/api/performanceHallMr/performanceHallMr";
import { getToken } from "@/utils/auth";
export default {
  name: "addAndEdit",
  data() {
    return {
      title: "编辑",
      model: "EDIT",
      activeName: '01',
      open: false,
      loading: false,
      form: {
        id: undefined,
        type: "",
        content: "",
      },
      rules: {
        name: [{ required: true, message: "请输入演出厅名称", trigger: ["change","blur"] }],
        seatImg: [{ required: true, message: "请上传票区图", trigger: ["change","blur"] }],
        theatreId: [
          { required: true, message: "请选择所属场馆", trigger: ["change","blur"] },
        ],
      },
      uploadObj: {
        url: process.env.VUE_APP_UPLOAD_FILE_API + "/upload/single/minio",
        Headers: { Authorization: "Bearer " + getToken() },
      },
      theatreList: [],
    };
  },
  methods: {
    /**
     * 打开弹框
     * @date 2023-11-22
     * @param {any} obj
     * @returns {any}
     */
    openDialog(title, obj) {
      this.open = true;
      this.reset();
      this.getList();
      if (obj){
        this.title = "编辑演出厅";
        this.$nextTick(() => {
          this.$set(this.form, 'id', obj.id)
          this.$set(this.form, 'name', obj.name)
          this.$set(this.form, 'seatImg', obj.seatImg)
          this.$set(this.form, 'theatreId', obj.theatreId)
          this.$forceUpdate()
        });
      }else{
        this.title = "添加演出厅";
        this.$nextTick(() => {
          this.$refs["form"].clearValidate();
        });
      }
    },
    /** 查询列表 */
    getList() {
      pageList(this.addDateRange({pageNum: 1, pageSize: 100}))
        .then(response => {
            this.theatreList = response.data.rows;
          }
        );
    },
    /**
     * 保存
     * @date 2023-11-22
     * @returns {any}
     */
    submitForm() {
      this.$refs["form"].validate(async (valid) => {
        if (valid) {
          try {
            this.loading = true;
            const { code } = await saveAndEdit({ ...this.form });
            if (code === 200) {
              this.$message.success("操作成功!");
              this.$emit("getList");
              this.cancel();
            }
          } catch (error) {
          } finally {
            this.loading = false;
          }
        }
      });
    },
    /**
     * 重置
     * @date 2023-11-22
     * @returns {any}
     */
    reset() {
      this.$set(this.form, 'id', '')
      this.$set(this.form, 'name', '')
      this.$set(this.form, 'seatImg', '')
      this.$set(this.form, 'theatreId', '')
    },
    /**
     * 关闭弹框
     * @date 2023-11-22
     * @returns {any}
     */
    cancel() {
      this.reset();
      this.open = false;
    },
    /**
     * 上传成功
     * @date 2023-11-22
     * @param {any} res
     * @returns {any}
     */
    handleAvatarSuccess(res) {
      if (res.code === 200) {
        // this.form.mainImg = res?.data?.url;
        this.$set(this.form, 'seatImg', res?.data?.url)
      }
    },
    /**
     * 上传文件之前之前
     * @date 2023-11-22
     * @param {any} file
     * @returns {any}
     */
    beforeAvatarUpload(file) {
      const isJPG = file.type === "image/jpeg" || "image/png";
      if (!isJPG) {
        this.$message.error("上传头像图片只能是jpg或png格式!");
      }
      return isJPG;
    },
    /**
     * 删除图片
     * @date 2023-11-22
     * @param {any} res
     * @returns {any}
     */
    removeImg() {
      this.$set(this.form, 'seatImg', "")
    }
  },
};
</script>

<style lang="scss" scoped>
.dialog {
  padding: 0 30px;
  max-height: 65vh;
  overflow-y: auto;
}
.dialog {
  padding: 0 30px;

  .color-class{
    width: 50px;
    height: 50px;
  }

  .avatar:hover{
    .img_remove{
      display: block;
    }
  }
  .avatar:before{
    .img_remove{
      display: none;
    }
  }
  .img_remove{
    position: absolute;
    display: none;
    left: 0;
    top: 0;
    width: 100px;
    height: 100px;
    background: #565454;
    opacity: 0.8;
    line-height: 100px;
  }

  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}
</style>
